package com.cbnanashi.entitybackup;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.UnsupportedEncodingException;
import java.net.URLEncoder;
import java.util.Arrays;
import java.util.LinkedList;
import java.util.List;
import org.apache.commons.httpclient.HttpClient;
import org.apache.commons.httpclient.HttpException;
import org.apache.commons.httpclient.HttpStatus;
import org.apache.commons.httpclient.methods.GetMethod;

public class EntityBackup {
	private static final String BACKUP_FILE_SUFFIX = ".txt";
	private static final String KEY_INDICATOR = "__key__";
	private static final String KIND_PARAM_NAME = "kind";
	private static final String CURSOR_PARAM_NAME = "cursor";
	private static final String KIND_GET_PARAM_NAME = "getKind";
	private static final String GAE_SYSTEM_KIND_PREFIX = "__";
	private static final String CURSOR_INDICATOR = "__cursor__";

	private String servletUrl;
	private List<String> kinds;

	// RXgN^
	public EntityBackup(String u, List<String> l) {
		servletUrl = u;
		kinds = l;
	}

	// 1:URLA2ȍ~:KindiIvVj
	public static void main(String[] args) {
		if (args.length == 0) {
			System.out.println("Usage:\tjava -jar entitybackup.jar url [kind...]");
			System.exit(99);
		}

		String url = args[0];

		List<String> kinds = new LinkedList<String>();
		if (args.length > 1) {
			kinds.addAll(Arrays.asList(args));
			kinds.remove(0);
		}

		EntityBackup backupper = new EntityBackup(url, kinds);

		try {
			backupper.backup();
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(1);
		}
		System.exit(0);
	}

	// backup
	private void backup() {
		log("URL̃AvP[VpăobNAbv܂BURL:" + servletUrl);

		// Kindw肳ĂȂΓǂݍ
		if (kinds == null || kinds.isEmpty()) {
			loadKinds();
		}

		StringBuilder sb = new StringBuilder();
		for (String kind : kinds) {
			sb.append(kind).append('\n');
		}
		log("KindΏۂƂ܂B\n" + sb.toString());

		// KindƂɏ
		for (String kind : kinds) {
			backupKind(kind);
		}

		log("܂B");
	}

	// Kindbackup
	private void backupKind(String kind) {
		// o̓t@CJ
		BufferedWriter out;
		try {
			out = new BufferedWriter(new FileWriter(kind + BACKUP_FILE_SUFFIX));
		} catch (IOException e) {
			throw new IllegalStateException("t@CJ܂B", e);
		}
		String cursor = null;

		// T[o擾At@Cɏo͂
		int count = 0;
		for (;;) {
			String url = servletUrl + "?" + KIND_PARAM_NAME + "=" + encode(kind);
			if (cursor != null) {
				url += "&" + CURSOR_PARAM_NAME + "=" + encode(cursor);
			}
			log("URL擾B");
			log(url);

			String cursorLine = null; // ̃J[\ws̓e

			HttpClient client = new HttpClient();
			GetMethod get = null;
			try {
				// NGXg𑗐M
				get = new GetMethod(url);

				int status = client.executeMethod(get);
				if (status == HttpStatus.SC_NOT_FOUND) { // YȂ
					break;
				} else if (status != HttpStatus.SC_OK) {
					throw new IllegalStateException("Kind擾̃G[łBstatus:" + status);
				}

				// ʂt@Cɏo͂
				BufferedReader in = new BufferedReader(new InputStreamReader(get.getResponseBodyAsStream(), "UTF-8"));
				for (String line; (line = in.readLine()) != null;) {
					if (line.startsWith(KEY_INDICATOR)) { // L[wsEntity̌JEg
						count++;
					}
					if (line.startsWith(CURSOR_INDICATOR)) { // J[\ws?
						cursorLine = line;
					} else {
						// J[\wsȊOo͂
						try {
							out.write(line);
							out.write('\n');
						} catch (IOException e) {
							throw new IllegalStateException("t@Co̓G[łB", e);
						}
					}
				}
				in.close();
			} catch (HttpException e) {
				throw new IllegalStateException("vgRG[łB", e);
			} catch (IOException e) {
				throw new IllegalStateException("ʐMG[łB", e);
			} finally {
				if (get != null) {
					get.releaseConnection();
				}
			}

			if (cursorLine == null) {
				break;
			}

			// ̃J[\w肷
			cursor = cursorLine.substring(cursorLine.indexOf('\t') + 1);
		}

		// t@CďI
		try {
			out.close();
		} catch (IOException e) {
			throw new IllegalStateException("t@Co̓G[łB", e);
		}

		log("Kind:" + kind + "" + count + "擾܂B");
	}

	private String encode(String s) {
		try {
			return URLEncoder.encode(s, "UTF-8");
		} catch (UnsupportedEncodingException e) {
			// NȂ͂
			return s;
		}
	}

	private void log(String s) {
		System.out.println(s);
	}

	// T[oKind擾
	private void loadKinds() {
		String url = servletUrl + "?" + KIND_GET_PARAM_NAME + "=1";

		HttpClient client = new HttpClient();
		GetMethod get = null;
		try {
			get = new GetMethod(url);

			int status = client.executeMethod(get);
			if (status != HttpStatus.SC_OK) {
				throw new IllegalStateException("Kind擾̃G[łBstatus:" + status);
			}

			BufferedReader in = new BufferedReader(new InputStreamReader(get.getResponseBodyAsStream(), "UTF-8"));
			kinds = new LinkedList<String>();
			for (String kind; (kind = in.readLine()) != null;) {
				if (!kind.startsWith(GAE_SYSTEM_KIND_PREFIX)) { // GAEKindȊOL^
					kinds.add(kind);
				}
			}
			in.close();
		} catch (HttpException e) {
			throw new IllegalStateException("vgRG[łB", e);
		} catch (IOException e) {
			throw new IllegalStateException("ʐMG[łB", e);
		} finally {
			if (get != null) {
				get.releaseConnection();
			}
		}
	}
}
